package com.yfd.platform.modules.storage.model.param;


import com.yfd.platform.annotation.StorageParamItem;
import lombok.Getter;

/**
 * OneDrive 初始化参数
 *
 * @author zhengsl
 */
@Getter
public class OneDriveChinaParam extends OneDriveParam {

	@StorageParamItem(name = "clientId", defaultValue = "${zfile.onedrive-china.clientId}", order = 1)
	private String clientId;

	@StorageParamItem(name = "SecretKey", defaultValue = "${zfile.onedrive-china.clientSecret}", order = 2)
	private String clientSecret;

	@StorageParamItem(name = "回调地址", description = "如使用自定义 api, 需将此处默认的域名修改为您的域名, 且需在 api 中配置为回调域名.",
			defaultValue = "${zfile.onedrive-china.redirectUri}", order = 3)
	private String redirectUri;

	@StorageParamItem(name = "访问令牌", link = "/onedrive/china-authorize", linkName = "前往获取令牌", order = 3)
	private String accessToken;

}
